unit terminal;
//===========================================================
// This small form demonstrate capacity of TnrComm component.
// Copyright(C) 1997,2000 Roman Novgorodov (noro@chat.ru)
interface

uses
  Windows, Messages, Classes,Controls, Forms,
  ToolWin, ComCtrls, StdCtrls, nrcomm, ExtCtrls, Menus,
  {$IFDEF VER100}
      Dialogs;
  {$ELSE}
     Dialogs, ImgList ;
  {$ENDIF}


type
  TForm1 = class(TForm)
    Bar: TStatusBar;
    Panel1: TPanel;
    M0: TMemo;
    ToolBar2: TToolBar;
    Bar0: TStatusBar;
    Panel2: TPanel;
    M1: TMemo;
    ToolBar3: TToolBar;
    btnRD1: TToolButton;
    btnTD1: TToolButton;
    btnRing1: TToolButton;
    btnDSR1: TToolButton;
    btnCTS1: TToolButton;
    Bar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    mnuActive: TMenuItem;
    mnuPort: TMenuItem;
    N1: TMenuItem;
    mnuProp: TMenuItem;
    mnuCOM1: TMenuItem;
    COM21: TMenuItem;
    COM31: TMenuItem;
    COM41: TMenuItem;
    Splitter1: TSplitter;
    N21: TMenuItem;
    ImageList1: TImageList;
    btnRD0: TToolButton;
    btnTD0: TToolButton;
    btnRing0: TToolButton;
    btnDSR0: TToolButton;
    btnCTS0: TToolButton;
    btnRLSD0: TToolButton;
    btnRLSD1: TToolButton;
    mnuTerminal: TMenuItem;
    tuNone1: TMenuItem;
    tuSend1: TMenuItem;
    tuReceive1: TMenuItem;
    tuBoth1: TMenuItem;
    Com0: TnrComm;
    Com1: TnrComm;
    SendData1: TMenuItem;
    Dlg: TOpenDialog;
    N2: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    ToolButton9: TToolButton;
    ToolButton10: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    mnuEventChar: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure ComListEvent(I: Integer; List: TEventList);
    procedure ComSended(Com:TnrComm);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure mnuActiveClick(Sender: TObject);
    procedure mnuPropClick(Sender: TObject);
    procedure mnuCOM1Click(Sender: TObject);
    procedure M0MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure N21Click(Sender: TObject);
    procedure Com0TraceState(Com: TnrComm; Event: TTraceState);
    procedure Com1TraceState(Com: TnrComm; Event: TTraceState);
    procedure tuNone1Click(Sender: TObject);
    procedure DCB1Click(Sender: TObject);
    procedure SendData1Click(Sender: TObject);
    procedure Com0ListEvent(Com:TnrComm;I: Integer; List: TEventList);
    procedure Com1ListEvent(Com:TnrComm;I: Integer; List: TEventList);
    procedure Com0AfterReceive(Com: TnrComm; Buffer: Pointer;
      Received: Cardinal);
    procedure DTRONOFF1Click(Sender: TObject);
    procedure XONOFF1Click(Sender: TObject);
    procedure RTSONOFF1Click(Sender: TObject);
    procedure BreakONOFF1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure ToolButton9Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure ToolButton11Click(Sender: TObject);
    procedure ToolButton14Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure mnuEventCharClick(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;
  Com:TnrComm;

implementation
uses sysutils;    
{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  Com0.EventList.AddNewEvent(PChar('OK'),2);
  Com0.EventList.AddNewEvent(PChar('RING'),4);
  Com1.EventList.AddNewEvent(PChar('Come as you are'),15);
  Com1.EventList.AddNewEvent(PChar('RING'),4);
  Com0.Active:=True;
  Com1.Active:=True;
  Com0.EventListOnLine:=True;
  Com1.EventListOnLine:=True;
end;

procedure TForm1.ComListEvent(I: Integer; List: TEventList);
begin
  Bar.Panels[2].Text:='COMPORT Status:'+List.EventString[i];
end;

procedure TForm1.ComSended(Com:TnrComm);
var Bar:TStatusBar;
begin
  if Com=Com0 then Bar:=Bar0 else Bar:=Bar1;
  Bar.Panels[1].Text:='Out:'+IntToStr(Com.TotalSended);
  Bar.Panels[2].Text:='Status:None.';
  if Boolean(Com.Tag) then begin
     Com.Tag:=Integer(False);
     Bar.Panels[2].Text:='Long Transmit Complete !';
     Bar.Repaint;
  end;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
var i:integer;
begin
  mnuActive.Checked:=com.Active;
  mnuEventChar.Checked:=Boolean(tsRxFlag in com.TraceStates);
  for i:=0 to mnuPort.Count-1 do
     mnuPort.Items[i].Checked:=Boolean(Integer(com.ComPort)=i);
  for i:=0 to mnuTerminal.Count-1 do
     mnuTerminal.Items[i].Checked:=Boolean(Integer(com.TerminalUsage)=i);
end;

procedure TForm1.mnuActiveClick(Sender: TObject);
begin
  com.Active:=not com.Active;
end;

procedure TForm1.mnuPropClick(Sender: TObject);
begin
  com.ConfigDialog;
end;

procedure TForm1.mnuCOM1Click(Sender: TObject);
begin
  com.ComPort:=TComPort(TMenuItem(Sender).MenuIndex);
  com.Active:=True;
end;

procedure TForm1.M0MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if(TMemo(Sender)=M0)
    then com:=Com0
    else com:=Com1;
end;

procedure TForm1.N21Click(Sender: TObject);
var s:PCommProp;
begin
  s:=com.CommProp;
  ShowMessageFmt('Ready for read = %u '#13'Size Out Buf=%u'#13'Size In  Buf=%u'#13+
     'MaxSize Out Buf=%u'#13'maxSize In  Buf=%u'  ,[com.ReadyForRead,s.dwCurrentTxQueue,
     s.dwCurrentRxQueue,s.dwMaxTxQueue,s.dwMaxRxQueue])
end;

procedure TForm1.Com0TraceState(Com: TnrComm; Event: TTraceState);
var ms:TModemSignals;
    Buffer:PChar;
begin
  if tsRxFlag=Event then begin
     Buffer:=StrAlloc(Com.ReadyForRead);
     Com.ReadAll(Buffer);
     M0.Lines.Add(String(Buffer));
     StrDispose(Buffer);
     M0.Lines.Add('RxFlag Received Event Char !!!');
   end;
  ms:=Com.ModemSignals;
  if msRing in ms then btnRing0.ImageIndex:=1
                  else btnRing0.ImageIndex:=0;
  if msDSR in ms then btnDSR0.ImageIndex:=1
                 else btnDSR0.ImageIndex:=0;
  if msCTS in ms then btnCTS0.ImageIndex:=1
                 else btnCTS0.ImageIndex:=0;
  if msRLSD in ms then btnRLSD0.ImageIndex:=1
                  else btnRLSD0.ImageIndex:=0;
  ToolBar2.Repaint;
end;

procedure TForm1.Com1TraceState(Com: TnrComm; Event: TTraceState);
var ms:TModemSignals;
    Buffer:PChar;
begin
  if tsRxFlag=Event then begin
     Buffer:=StrAlloc(Com.ReadyForRead);
     Com.ReadAll(Buffer);
     M1.Lines.Add(String(Buffer));
     StrDispose(Buffer);
     M1.Lines.Add('RxFlag Received Event Char !!!');
   end;
  ms:=Com.ModemSignals;
  if msRing in ms then btnRing1.ImageIndex:=1
                   else btnRing1.ImageIndex:=0;
  if msDSR in ms then btnDSR1.ImageIndex:=1
                 else btnDSR1.ImageIndex:=0;
  if msCTS in ms then btnCTS1.ImageIndex:=1
                 else btnCTS1.ImageIndex:=0;
  if msRLSD in ms then btnRLSD1.ImageIndex:=1
                  else btnRLSD1.ImageIndex:=0;
  if msRLSD in ms then btnRLSD1.ImageIndex:=1
                  else btnRLSD1.ImageIndex:=0;
  ToolBar3.Repaint;
end;

procedure TForm1.tuNone1Click(Sender: TObject);
begin
  com.TerminalUsage:=TTerminalUsage(TMenuItem(Sender).MenuIndex);
end;

procedure TForm1.DCB1Click(Sender: TObject);
begin
  ShowMessageFmt('%xh',[com.DCB.Flags]);
end;

procedure TForm1.SendData1Click(Sender: TObject);
var Buf:pointer;
{$IFDEF VER100} //- Delphi3
    h,n,n2:integer;
{$ELSE}
    h,n,n2:cardinal;
{$ENDIF}
begin
  with Dlg do if Execute then begin
    h:=CreateFile(PChar(FileName),GENERIC_READ,0,nil,OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL,0);
    n:=GetFileSize(h,@n2);
    GetMem(Buf,n);
    ReadFile(h,Buf^,n,n,Nil);
    CloseHandle(h);
    com.Tag:=Integer(True);    //The flag of Long transmit
    com.SendData(Buf,N);
  end;
end;

procedure TForm1.Com0ListEvent(Com:TnrComm;I: Integer; List: TEventList);
begin
  Bar0.Panels[2].Text:=List.EventString[i];
  Bar0.Repaint;
end;

procedure TForm1.Com1ListEvent(Com:TnrComm;I: Integer; List: TEventList);
begin
  Bar1.Panels[2].Text:=List.EventString[i];
  Bar1.Repaint;
end;

procedure TForm1.Com0AfterReceive(Com: TnrComm; Buffer: Pointer;
  Received: Cardinal);
var Bar:TStatusBar;
begin
  if Com=Com0 then Bar:=Bar0 else Bar:=Bar1;
  Bar.Panels[0].Text:='In:'+IntToStr(Com.TotalReceived);
end;

procedure TForm1.DTRONOFF1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
  Com.SetStateDTR(TMenuItem(Sender).Checked);
end;

procedure TForm1.XONOFF1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
  Com.SetStateX(TMenuItem(Sender).Checked);
end;

procedure TForm1.RTSONOFF1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
  Com.SetStateRTS(TMenuItem(Sender).Checked);
end;

procedure TForm1.BreakONOFF1Click(Sender: TObject);
begin
  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
  Com.SetStateBreak(TMenuItem(Sender).Checked);

end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
  Com0.SetStateDTR(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton7Click(Sender: TObject);
begin
  Com1.SetStateDTR(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
  Com0.SetStateRTS(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton8Click(Sender: TObject);
begin
  Com1.SetStateRTS(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
  Com0.SetStateX(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton9Click(Sender: TObject);
begin
  Com1.SetStateX(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton4Click(Sender: TObject);
begin
  Com0.SetStateBreak(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton10Click(Sender: TObject);
begin
  Com1.SetStateBreak(TToolButton(Sender).Down);
end;

procedure TForm1.ToolButton11Click(Sender: TObject);
begin
  Com0.SendChar(Com0.EventChar);
end;

procedure TForm1.ToolButton14Click(Sender: TObject);
begin
  Com1.SendChar(Com1.EventChar);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  ShowMessage('Use popup menu (right mouse click)'#13' For full demo capacity !' );
end;

procedure TForm1.mnuEventCharClick(Sender: TObject);
begin

  TMenuItem(Sender).Checked:=not TMenuItem(Sender).Checked;
  if TMenuItem(Sender).Checked then Com.TraceStates:=[tsRxFlag]
  else Com.TraceStates:=[tsRxChar,tsCTS,tsDSR,tsRLSD,tsRing]

end;

end.
